/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package fr.inria.aoste.syndex.modeler.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.topcased.modeler.providers.ILabelFeatureProvider;

import fr.inria.aoste.syndex.util.SyndexAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances.
 * 
 * @generated
 */
public class SyndexModelerProviderAdapterFactory extends SyndexAdapterFactory implements ComposeableAdapterFactory,
		IChangeNotifier, IDisposable
{
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * 
	 * @generated
	 */
	private ComposedAdapterFactory						parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * 
	 * @generated
	 */
	private IChangeNotifier								changeNotifier	= new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	private Collection									supportedTypes	= new ArrayList();

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Actuator} instances.
	 * 
	 * @generated
	 */
	private ActuatorModelerProvider						actuatorModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.AtomicApplicationComponent}
	 * instances.
	 * 
	 * @generated
	 */
	private AtomicApplicationComponentModelerProvider	atomicapplicationcomponentModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Port} instances.
	 * 
	 * @generated
	 */
	private PortModelerProvider							portModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.NamedElement} instances.
	 * 
	 * @generated
	 */
	private NamedElementModelerProvider					namedelementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ApplicationComponent} instances.
	 * 
	 * @generated
	 */
	private ApplicationComponentModelerProvider			applicationcomponentModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Sensor} instances.
	 * 
	 * @generated
	 */
	private SensorModelerProvider						sensorModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Application} instances.
	 * 
	 * @generated
	 */
	private ApplicationModelerProvider					applicationModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Input} instances.
	 * 
	 * @generated
	 */
	private InputModelerProvider						inputModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Component} instances.
	 * 
	 * @generated
	 */
	private ComponentModelerProvider					componentModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Output} instances.
	 * 
	 * @generated
	 */
	private OutputModelerProvider						outputModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Function} instances.
	 * 
	 * @generated
	 */
	private FunctionModelerProvider						functionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Constant} instances.
	 * 
	 * @generated
	 */
	private ConstantModelerProvider						constantModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Delay} instances.
	 * 
	 * @generated
	 */
	private DelayModelerProvider						delayModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Connection} instances.
	 * 
	 * @generated
	 */
	private ConnectionModelerProvider					connectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.DataConnection} instances.
	 * 
	 * @generated
	 */
	private DataConnectionModelerProvider				dataconnectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Instance} instances.
	 * 
	 * @generated
	 */
	private InstanceModelerProvider						instanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ComponentInstance} instances.
	 * 
	 * @generated
	 */
	private ComponentInstanceModelerProvider			componentinstanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.PortInstance} instances.
	 * 
	 * @generated
	 */
	private PortInstanceModelerProvider					portinstanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INInstance} instances.
	 * 
	 * @generated
	 */
	private INInstanceModelerProvider					ininstanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.OutInstance} instances.
	 * 
	 * @generated
	 */
	private OutInstanceModelerProvider					outinstanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDependencyIN} instances.
	 * 
	 * @generated
	 */
	private InternalDependencyINModelerProvider			internaldependencyinModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDependencyOUT} instances.
	 * 
	 * @generated
	 */
	private InternalDependencyOUTModelerProvider		internaldependencyoutModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConnecteableElement} instances.
	 * 
	 * @generated
	 */
	private ConnecteableElementModelerProvider			connecteableelementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InCondPort} instances.
	 * 
	 * @generated
	 */
	private InCondPortModelerProvider					incondportModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.HardwareComponent} instances.
	 * 
	 * @generated
	 */
	private HardwareComponentModelerProvider			hardwarecomponentModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Hardware} instances.
	 * 
	 * @generated
	 */
	private HardwareModelerProvider						hardwareModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Media} instances.
	 * 
	 * @generated
	 */
	private MediaModelerProvider						mediaModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.FPGA} instances.
	 * 
	 * @generated
	 */
	private FPGAModelerProvider							fpgaModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Asic} instances.
	 * 
	 * @generated
	 */
	private AsicModelerProvider							asicModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.DSP} instances.
	 * 
	 * @generated
	 */
	private DSPModelerProvider							dspModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.RAM} instances.
	 * 
	 * @generated
	 */
	private RAMModelerProvider							ramModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SAM} instances.
	 * 
	 * @generated
	 */
	private SAMModelerProvider							samModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SAMPTP} instances.
	 * 
	 * @generated
	 */
	private SAMPTPModelerProvider						samptpModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.HWConnection} instances.
	 * 
	 * @generated
	 */
	private HWConnectionModelerProvider					hwconnectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConnectionHW} instances.
	 * 
	 * @generated
	 */
	private ConnectionHWModelerProvider					connectionhwModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Caracteristics} instances.
	 * 
	 * @generated
	 */
	private CaracteristicsModelerProvider				caracteristicsModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.AssociationSWtoHW} instances.
	 * 
	 * @generated
	 */
	private AssociationSWtoHWModelerProvider			associationswtohwModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.AssociationComtoProc} instances.
	 * 
	 * @generated
	 */
	private AssociationComtoProcModelerProvider			associationcomtoprocModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Duration} instances.
	 * 
	 * @generated
	 */
	private DurationModelerProvider						durationModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.EnumLitDuration} instances.
	 * 
	 * @generated
	 */
	private EnumLitDurationModelerProvider				enumlitdurationModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Datatype} instances.
	 * 
	 * @generated
	 */
	private DatatypeModelerProvider						datatypeModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Size} instances.
	 * 
	 * @generated
	 */
	private SizeModelerProvider							sizeModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Array} instances.
	 * 
	 * @generated
	 */
	private ArrayModelerProvider						arrayModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Vector} instances.
	 * 
	 * @generated
	 */
	private VectorModelerProvider						vectorModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Processor} instances.
	 * 
	 * @generated
	 */
	private ProcessorModelerProvider					processorModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Element} instances.
	 * 
	 * @generated
	 */
	private ElementModelerProvider						elementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SynDEx} instances.
	 * 
	 * @generated
	 */
	private SynDExModelerProvider						syndexModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ApplicationConnection} instances.
	 * 
	 * @generated
	 */
	private ApplicationConnectionModelerProvider		applicationconnectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalStructure} instances.
	 * 
	 * @generated
	 */
	private InternalStructureModelerProvider			internalstructureModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ElementaryStructure} instances.
	 * 
	 * @generated
	 */
	private ElementaryStructureModelerProvider			elementarystructureModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.CompoundStructure} instances.
	 * 
	 * @generated
	 */
	private CompoundStructureModelerProvider			compoundstructureModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INOUT} instances.
	 * 
	 * @generated
	 */
	private INOUTModelerProvider						inoutModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDataConnection} instances.
	 * 
	 * @generated
	 */
	private InternalDataConnectionModelerProvider		internaldataconnectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ParameterDeclaration} instances.
	 * 
	 * @generated
	 */
	private ParameterDeclarationModelerProvider			parameterdeclarationModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ParameterValue} instances.
	 * 
	 * @generated
	 */
	private ParameterValueModelerProvider				parametervalueModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConditionedStructure} instances.
	 * 
	 * @generated
	 */
	private ConditionedStructureModelerProvider			conditionedstructureModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Condition} instances.
	 * 
	 * @generated
	 */
	private ConditionModelerProvider					conditionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.RepetitionConnection} instances.
	 * 
	 * @generated
	 */
	private RepetitionConnectionModelerProvider			repetitionconnectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INOUTInstance} instances.
	 * 
	 * @generated
	 */
	private INOUTInstanceModelerProvider				inoutinstanceModelerProvider;

	/**
	 * This constructs an instance.
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public SyndexModelerProviderAdapterFactory()
	{
		supportedTypes.add(ILabelFeatureProvider.class);
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * 
	 * @return the root AdapterFactory
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory()
	{
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * 
	 * @param parentAdapterFactory
	 *        the new parent adapter factory
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
	{
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * @param type
	 *        the type to test
	 * @return true if supported
	 * 
	 * @generated
	 */
	public boolean isFactoryForType(Object type)
	{
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * 
	 * @param notifier
	 *        the notifier
	 * @param type
	 *        the object to adapt
	 * @return the Adapter the created adatper
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type)
	{
		return super.adapt(notifier, this);
	}

	/**
	 * @param object
	 *        the object to adapt
	 * @param type
	 *        the type to adapt
	 * @return the adapted Object
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public Object adapt(Object object, Object type)
	{
		if (isFactoryForType(type))
		{
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class) type).isInstance(adapter)))
			{
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * 
	 * @param notifyChangedListener
	 *        the listener to add
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * 
	 * @param notifyChangedListener
	 *        the listener to remove
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * 
	 * @param notification
	 *        the notification to fire
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification)
	{
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null)
		{
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Actuator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createActuatorAdapter()
	{
		if (actuatorModelerProvider == null)
		{
			actuatorModelerProvider = new ActuatorModelerProvider(this);
		}

		return actuatorModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.AtomicApplicationComponent}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAtomicApplicationComponentAdapter()
	{
		if (atomicapplicationcomponentModelerProvider == null)
		{
			atomicapplicationcomponentModelerProvider = new AtomicApplicationComponentModelerProvider(this);
		}

		return atomicapplicationcomponentModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Port}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createPortAdapter()
	{
		if (portModelerProvider == null)
		{
			portModelerProvider = new PortModelerProvider(this);
		}

		return portModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.NamedElement}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createNamedElementAdapter()
	{
		if (namedelementModelerProvider == null)
		{
			namedelementModelerProvider = new NamedElementModelerProvider(this);
		}

		return namedelementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ApplicationComponent}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createApplicationComponentAdapter()
	{
		if (applicationcomponentModelerProvider == null)
		{
			applicationcomponentModelerProvider = new ApplicationComponentModelerProvider(this);
		}

		return applicationcomponentModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Sensor}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSensorAdapter()
	{
		if (sensorModelerProvider == null)
		{
			sensorModelerProvider = new SensorModelerProvider(this);
		}

		return sensorModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Application}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createApplicationAdapter()
	{
		if (applicationModelerProvider == null)
		{
			applicationModelerProvider = new ApplicationModelerProvider(this);
		}

		return applicationModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Input}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInputAdapter()
	{
		if (inputModelerProvider == null)
		{
			inputModelerProvider = new InputModelerProvider(this);
		}

		return inputModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Component}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createComponentAdapter()
	{
		if (componentModelerProvider == null)
		{
			componentModelerProvider = new ComponentModelerProvider(this);
		}

		return componentModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Output}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOutputAdapter()
	{
		if (outputModelerProvider == null)
		{
			outputModelerProvider = new OutputModelerProvider(this);
		}

		return outputModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Function}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createFunctionAdapter()
	{
		if (functionModelerProvider == null)
		{
			functionModelerProvider = new FunctionModelerProvider(this);
		}

		return functionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Constant}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantAdapter()
	{
		if (constantModelerProvider == null)
		{
			constantModelerProvider = new ConstantModelerProvider(this);
		}

		return constantModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Delay}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDelayAdapter()
	{
		if (delayModelerProvider == null)
		{
			delayModelerProvider = new DelayModelerProvider(this);
		}

		return delayModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Connection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConnectionAdapter()
	{
		if (connectionModelerProvider == null)
		{
			connectionModelerProvider = new ConnectionModelerProvider(this);
		}

		return connectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.DataConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDataConnectionAdapter()
	{
		if (dataconnectionModelerProvider == null)
		{
			dataconnectionModelerProvider = new DataConnectionModelerProvider(this);
		}

		return dataconnectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Instance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInstanceAdapter()
	{
		if (instanceModelerProvider == null)
		{
			instanceModelerProvider = new InstanceModelerProvider(this);
		}

		return instanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ComponentInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createComponentInstanceAdapter()
	{
		if (componentinstanceModelerProvider == null)
		{
			componentinstanceModelerProvider = new ComponentInstanceModelerProvider(this);
		}

		return componentinstanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.PortInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createPortInstanceAdapter()
	{
		if (portinstanceModelerProvider == null)
		{
			portinstanceModelerProvider = new PortInstanceModelerProvider(this);
		}

		return portinstanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createINInstanceAdapter()
	{
		if (ininstanceModelerProvider == null)
		{
			ininstanceModelerProvider = new INInstanceModelerProvider(this);
		}

		return ininstanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.OutInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOutInstanceAdapter()
	{
		if (outinstanceModelerProvider == null)
		{
			outinstanceModelerProvider = new OutInstanceModelerProvider(this);
		}

		return outinstanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDependencyIN}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInternalDependencyINAdapter()
	{
		if (internaldependencyinModelerProvider == null)
		{
			internaldependencyinModelerProvider = new InternalDependencyINModelerProvider(this);
		}

		return internaldependencyinModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDependencyOUT}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInternalDependencyOUTAdapter()
	{
		if (internaldependencyoutModelerProvider == null)
		{
			internaldependencyoutModelerProvider = new InternalDependencyOUTModelerProvider(this);
		}

		return internaldependencyoutModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConnecteableElement}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConnecteableElementAdapter()
	{
		if (connecteableelementModelerProvider == null)
		{
			connecteableelementModelerProvider = new ConnecteableElementModelerProvider(this);
		}

		return connecteableelementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InCondPort}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInCondPortAdapter()
	{
		if (incondportModelerProvider == null)
		{
			incondportModelerProvider = new InCondPortModelerProvider(this);
		}

		return incondportModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.HardwareComponent}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createHardwareComponentAdapter()
	{
		if (hardwarecomponentModelerProvider == null)
		{
			hardwarecomponentModelerProvider = new HardwareComponentModelerProvider(this);
		}

		return hardwarecomponentModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Hardware}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createHardwareAdapter()
	{
		if (hardwareModelerProvider == null)
		{
			hardwareModelerProvider = new HardwareModelerProvider(this);
		}

		return hardwareModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Media}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createMediaAdapter()
	{
		if (mediaModelerProvider == null)
		{
			mediaModelerProvider = new MediaModelerProvider(this);
		}

		return mediaModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.FPGA}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createFPGAAdapter()
	{
		if (fpgaModelerProvider == null)
		{
			fpgaModelerProvider = new FPGAModelerProvider(this);
		}

		return fpgaModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Asic}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAsicAdapter()
	{
		if (asicModelerProvider == null)
		{
			asicModelerProvider = new AsicModelerProvider(this);
		}

		return asicModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.DSP}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDSPAdapter()
	{
		if (dspModelerProvider == null)
		{
			dspModelerProvider = new DSPModelerProvider(this);
		}

		return dspModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.RAM}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRAMAdapter()
	{
		if (ramModelerProvider == null)
		{
			ramModelerProvider = new RAMModelerProvider(this);
		}

		return ramModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SAM}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSAMAdapter()
	{
		if (samModelerProvider == null)
		{
			samModelerProvider = new SAMModelerProvider(this);
		}

		return samModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SAMPTP}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSAMPTPAdapter()
	{
		if (samptpModelerProvider == null)
		{
			samptpModelerProvider = new SAMPTPModelerProvider(this);
		}

		return samptpModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.HWConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createHWConnectionAdapter()
	{
		if (hwconnectionModelerProvider == null)
		{
			hwconnectionModelerProvider = new HWConnectionModelerProvider(this);
		}

		return hwconnectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConnectionHW}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConnectionHWAdapter()
	{
		if (connectionhwModelerProvider == null)
		{
			connectionhwModelerProvider = new ConnectionHWModelerProvider(this);
		}

		return connectionhwModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Caracteristics}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCaracteristicsAdapter()
	{
		if (caracteristicsModelerProvider == null)
		{
			caracteristicsModelerProvider = new CaracteristicsModelerProvider(this);
		}

		return caracteristicsModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.AssociationSWtoHW}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAssociationSWtoHWAdapter()
	{
		if (associationswtohwModelerProvider == null)
		{
			associationswtohwModelerProvider = new AssociationSWtoHWModelerProvider(this);
		}

		return associationswtohwModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.AssociationComtoProc}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAssociationComtoProcAdapter()
	{
		if (associationcomtoprocModelerProvider == null)
		{
			associationcomtoprocModelerProvider = new AssociationComtoProcModelerProvider(this);
		}

		return associationcomtoprocModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Duration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDurationAdapter()
	{
		if (durationModelerProvider == null)
		{
			durationModelerProvider = new DurationModelerProvider(this);
		}

		return durationModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.EnumLitDuration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createEnumLitDurationAdapter()
	{
		if (enumlitdurationModelerProvider == null)
		{
			enumlitdurationModelerProvider = new EnumLitDurationModelerProvider(this);
		}

		return enumlitdurationModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Datatype}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDatatypeAdapter()
	{
		if (datatypeModelerProvider == null)
		{
			datatypeModelerProvider = new DatatypeModelerProvider(this);
		}

		return datatypeModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Size}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSizeAdapter()
	{
		if (sizeModelerProvider == null)
		{
			sizeModelerProvider = new SizeModelerProvider(this);
		}

		return sizeModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Array}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArrayAdapter()
	{
		if (arrayModelerProvider == null)
		{
			arrayModelerProvider = new ArrayModelerProvider(this);
		}

		return arrayModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Vector}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createVectorAdapter()
	{
		if (vectorModelerProvider == null)
		{
			vectorModelerProvider = new VectorModelerProvider(this);
		}

		return vectorModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Processor}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createProcessorAdapter()
	{
		if (processorModelerProvider == null)
		{
			processorModelerProvider = new ProcessorModelerProvider(this);
		}

		return processorModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Element}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createElementAdapter()
	{
		if (elementModelerProvider == null)
		{
			elementModelerProvider = new ElementModelerProvider(this);
		}

		return elementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SynDEx}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSynDExAdapter()
	{
		if (syndexModelerProvider == null)
		{
			syndexModelerProvider = new SynDExModelerProvider(this);
		}

		return syndexModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ApplicationConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createApplicationConnectionAdapter()
	{
		if (applicationconnectionModelerProvider == null)
		{
			applicationconnectionModelerProvider = new ApplicationConnectionModelerProvider(this);
		}

		return applicationconnectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalStructure}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInternalStructureAdapter()
	{
		if (internalstructureModelerProvider == null)
		{
			internalstructureModelerProvider = new InternalStructureModelerProvider(this);
		}

		return internalstructureModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ElementaryStructure}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createElementaryStructureAdapter()
	{
		if (elementarystructureModelerProvider == null)
		{
			elementarystructureModelerProvider = new ElementaryStructureModelerProvider(this);
		}

		return elementarystructureModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.CompoundStructure}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCompoundStructureAdapter()
	{
		if (compoundstructureModelerProvider == null)
		{
			compoundstructureModelerProvider = new CompoundStructureModelerProvider(this);
		}

		return compoundstructureModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INOUT}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createINOUTAdapter()
	{
		if (inoutModelerProvider == null)
		{
			inoutModelerProvider = new INOUTModelerProvider(this);
		}

		return inoutModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDataConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInternalDataConnectionAdapter()
	{
		if (internaldataconnectionModelerProvider == null)
		{
			internaldataconnectionModelerProvider = new InternalDataConnectionModelerProvider(this);
		}

		return internaldataconnectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ParameterDeclaration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createParameterDeclarationAdapter()
	{
		if (parameterdeclarationModelerProvider == null)
		{
			parameterdeclarationModelerProvider = new ParameterDeclarationModelerProvider(this);
		}

		return parameterdeclarationModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ParameterValue}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createParameterValueAdapter()
	{
		if (parametervalueModelerProvider == null)
		{
			parametervalueModelerProvider = new ParameterValueModelerProvider(this);
		}

		return parametervalueModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConditionedStructure}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConditionedStructureAdapter()
	{
		if (conditionedstructureModelerProvider == null)
		{
			conditionedstructureModelerProvider = new ConditionedStructureModelerProvider(this);
		}

		return conditionedstructureModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Condition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConditionAdapter()
	{
		if (conditionModelerProvider == null)
		{
			conditionModelerProvider = new ConditionModelerProvider(this);
		}

		return conditionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.RepetitionConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRepetitionConnectionAdapter()
	{
		if (repetitionconnectionModelerProvider == null)
		{
			repetitionconnectionModelerProvider = new RepetitionConnectionModelerProvider(this);
		}

		return repetitionconnectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INOUTInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createINOUTInstanceAdapter()
	{
		if (inoutinstanceModelerProvider == null)
		{
			inoutinstanceModelerProvider = new INOUTInstanceModelerProvider(this);
		}

		return inoutinstanceModelerProvider;
	}

	/**
	 * This disposes all of the item providers created by this factory.
	 * 
	 * @generated
	 */
	public void dispose()
	{
		if (actuatorModelerProvider != null)
		{
			actuatorModelerProvider.dispose();
		}
		if (atomicapplicationcomponentModelerProvider != null)
		{
			atomicapplicationcomponentModelerProvider.dispose();
		}
		if (portModelerProvider != null)
		{
			portModelerProvider.dispose();
		}
		if (namedelementModelerProvider != null)
		{
			namedelementModelerProvider.dispose();
		}
		if (applicationcomponentModelerProvider != null)
		{
			applicationcomponentModelerProvider.dispose();
		}
		if (sensorModelerProvider != null)
		{
			sensorModelerProvider.dispose();
		}
		if (applicationModelerProvider != null)
		{
			applicationModelerProvider.dispose();
		}
		if (inputModelerProvider != null)
		{
			inputModelerProvider.dispose();
		}
		if (componentModelerProvider != null)
		{
			componentModelerProvider.dispose();
		}
		if (outputModelerProvider != null)
		{
			outputModelerProvider.dispose();
		}
		if (functionModelerProvider != null)
		{
			functionModelerProvider.dispose();
		}
		if (constantModelerProvider != null)
		{
			constantModelerProvider.dispose();
		}
		if (delayModelerProvider != null)
		{
			delayModelerProvider.dispose();
		}
		if (connectionModelerProvider != null)
		{
			connectionModelerProvider.dispose();
		}
		if (dataconnectionModelerProvider != null)
		{
			dataconnectionModelerProvider.dispose();
		}
		if (instanceModelerProvider != null)
		{
			instanceModelerProvider.dispose();
		}
		if (componentinstanceModelerProvider != null)
		{
			componentinstanceModelerProvider.dispose();
		}
		if (portinstanceModelerProvider != null)
		{
			portinstanceModelerProvider.dispose();
		}
		if (ininstanceModelerProvider != null)
		{
			ininstanceModelerProvider.dispose();
		}
		if (outinstanceModelerProvider != null)
		{
			outinstanceModelerProvider.dispose();
		}
		if (internaldependencyinModelerProvider != null)
		{
			internaldependencyinModelerProvider.dispose();
		}
		if (internaldependencyoutModelerProvider != null)
		{
			internaldependencyoutModelerProvider.dispose();
		}
		if (connecteableelementModelerProvider != null)
		{
			connecteableelementModelerProvider.dispose();
		}
		if (incondportModelerProvider != null)
		{
			incondportModelerProvider.dispose();
		}
		if (hardwarecomponentModelerProvider != null)
		{
			hardwarecomponentModelerProvider.dispose();
		}
		if (hardwareModelerProvider != null)
		{
			hardwareModelerProvider.dispose();
		}
		if (mediaModelerProvider != null)
		{
			mediaModelerProvider.dispose();
		}
		if (fpgaModelerProvider != null)
		{
			fpgaModelerProvider.dispose();
		}
		if (asicModelerProvider != null)
		{
			asicModelerProvider.dispose();
		}
		if (dspModelerProvider != null)
		{
			dspModelerProvider.dispose();
		}
		if (ramModelerProvider != null)
		{
			ramModelerProvider.dispose();
		}
		if (samModelerProvider != null)
		{
			samModelerProvider.dispose();
		}
		if (samptpModelerProvider != null)
		{
			samptpModelerProvider.dispose();
		}
		if (hwconnectionModelerProvider != null)
		{
			hwconnectionModelerProvider.dispose();
		}
		if (connectionhwModelerProvider != null)
		{
			connectionhwModelerProvider.dispose();
		}
		if (caracteristicsModelerProvider != null)
		{
			caracteristicsModelerProvider.dispose();
		}
		if (associationswtohwModelerProvider != null)
		{
			associationswtohwModelerProvider.dispose();
		}
		if (associationcomtoprocModelerProvider != null)
		{
			associationcomtoprocModelerProvider.dispose();
		}
		if (durationModelerProvider != null)
		{
			durationModelerProvider.dispose();
		}
		if (enumlitdurationModelerProvider != null)
		{
			enumlitdurationModelerProvider.dispose();
		}
		if (datatypeModelerProvider != null)
		{
			datatypeModelerProvider.dispose();
		}
		if (sizeModelerProvider != null)
		{
			sizeModelerProvider.dispose();
		}
		if (arrayModelerProvider != null)
		{
			arrayModelerProvider.dispose();
		}
		if (vectorModelerProvider != null)
		{
			vectorModelerProvider.dispose();
		}
		if (processorModelerProvider != null)
		{
			processorModelerProvider.dispose();
		}
		if (elementModelerProvider != null)
		{
			elementModelerProvider.dispose();
		}
		if (syndexModelerProvider != null)
		{
			syndexModelerProvider.dispose();
		}
		if (applicationconnectionModelerProvider != null)
		{
			applicationconnectionModelerProvider.dispose();
		}
		if (internalstructureModelerProvider != null)
		{
			internalstructureModelerProvider.dispose();
		}
		if (elementarystructureModelerProvider != null)
		{
			elementarystructureModelerProvider.dispose();
		}
		if (compoundstructureModelerProvider != null)
		{
			compoundstructureModelerProvider.dispose();
		}
		if (inoutModelerProvider != null)
		{
			inoutModelerProvider.dispose();
		}
		if (internaldataconnectionModelerProvider != null)
		{
			internaldataconnectionModelerProvider.dispose();
		}
		if (parameterdeclarationModelerProvider != null)
		{
			parameterdeclarationModelerProvider.dispose();
		}
		if (parametervalueModelerProvider != null)
		{
			parametervalueModelerProvider.dispose();
		}
		if (conditionedstructureModelerProvider != null)
		{
			conditionedstructureModelerProvider.dispose();
		}
		if (conditionModelerProvider != null)
		{
			conditionModelerProvider.dispose();
		}
		if (repetitionconnectionModelerProvider != null)
		{
			repetitionconnectionModelerProvider.dispose();
		}
		if (inoutinstanceModelerProvider != null)
		{
			inoutinstanceModelerProvider.dispose();
		}
	}

}
